#include <stdio.h>
#include <stdlib.h>

void add_element_to_array(int *array, int elem, int *size, int *cap)
{
    if (*size > *cap)
    {
        *cap *= 2;
        array = (int *)realloc(array, sizeof(int) * (*cap));
    }
    array[(*size)++] = elem;
}

int main(int argc, char const *argv[])
{
    int m_cap, m_size = 0;
    int r = scanf("%d", &m_cap);
    if (r <= 0)
    {
        fprintf(stderr, "Error while reading input data!\n");
        return -1;
    }
    if (m_cap < 3) 
    {
        fprintf(stderr, "Capacity should be more than 3!\n");
        return -1;
    }
    
    int *d_arr = (int *)malloc(sizeof(int) * m_cap);           // how much memory we want to allocate
    printf("Size in mem of dym_arr:  %lu\n", sizeof(d_arr)); // m_size of pointer on the first element of the array

    add_element_to_array(d_arr, 3, &m_size, &m_cap);
    add_element_to_array(d_arr, 2, &m_size, &m_cap);
    add_element_to_array(d_arr, 1, &m_size, &m_cap);

    for (int i = 0; i < m_size; i++)
    {
        printf("dym_array[%d] = %d\n", i, d_arr[i]);
    }

    free(d_arr);
    return 0;
}
